<?php 
/* ----------------------------------------------------------------------------- 
Plugin Name: PixGallery
Version: 0.2.6
Plugin URI: http://www.nathanm.com/index.php/pixgallery/
Description: Hooks up all my pics foo.
Author: Nathan Moinvaziri
Author URI: http://www.nathanm.com/

See pixgallery.txt for release notes

 ------------------------------------------------------------------------------- */ 
/* Get query values 
/* ------------------------------------------------------------------------------ */

$QueryPathName	= "p";
$CollectionPath	= (isset($_REQUEST[$QueryPathName])) ? urldecode($_REQUEST[$QueryPathName]) : '/';
$GalleryPath	= "";

if (ini_get('safe_mode') == FALSE)
	set_time_limit(0); // Give enough time for thumbnails to create

if (ini_get('allow_url_fopen') != '1')
	@ini_set('allow_url_fopen', '1');

/* ------------------------------------------------------------------------------ */
/* Default settings for plugin 
/* ------------------------------------------------------------------------------ */

$PixGallery_Columns					= '3'; 
$PixGallery_Rows					= '0'; 
$PixGallery_ImageWidth				= '150';
$PixGallery_ImageHeight				= '100';
$PixGallery_ImageHeightLarge		= '0';
$PixGallery_ImageWidthLarge			= '600';
$PixGallery_RootCache				= "/images/cache/"; 
$PixGallery_ReduceOriginalsWidth	= '1024';
$PixGallery_ReduceOriginalsHeight	= '768';
$PixGallery_PopupMethod				= 'Layer';
$PixGlobal_Version					= '0.2.6';

/* The folder paths below are automatically determined by PixGallery_DeterminePaths */

$WebsiteUrl							= "http://www.nathanm.com/index.php/photos/"; 
$WebsiteRoot						= "c:\\inetpub\\wwwroot\\nathanm.com\\"; 

/* ------------------------------------------------------------------------------ */
/* Load settings from database 
/* ------------------------------------------------------------------------------ */

PixGallery_DeterminePaths();
PixGallery_Options_Load();

/* ------------------------------------------------------------------------------ */
/* General purpose functions
/* ------------------------------------------------------------------------------ */

function PixGallery_PrintError($ErrorMessage)
{
	print("<font color=red>".$ErrorMessage."</font><br>");
}

function PixGallery_UrlGetFileExtension($Url)
{
	$FileName	= PixGallery_UrlGetFileName($Url);
	$LastDot	= strrpos($FileName, ".");
	
	if ($LastDot === FALSE)
		return "";

	return substr($FileName, $LastDot);
}

function PixGallery_UrlGetFileTitle($Url)
{
	$FileName = PixGallery_UrlGetFileName($Url);

	if (strrpos($FileName, ".") === FALSE)
		return $FileName;

	return substr($FileName, 0, strrpos($FileName, "."));
}

function PixGallery_UrlGetFileName($Url)
{
	$Url = str_replace("\\", "/", $Url);

	if (strrpos($Url, "/") === FALSE)
		return $Url;

	return substr($Url, strrpos($Url, "/") + 1);
}

function PixGallery_UrlGetPath($Url)
{
	$PathSplit = "/";

	if (strpos($Url, "/") === FALSE)
		$PathSplit = "\\";

	$PathEnd		= strrpos($Url, $PathSplit);
	$ProtocolStart	= strpos($Url, "://");

	if ($PathEnd === FALSE)
		return $PathSplit;
	
	$PathEnd += 1;

	if ($ProtocolStart != FALSE)
		{
		$ProtocolStart += 3;		
		$Url = substr($Url, $ProtocolStart);
		}

	$PathStart = strpos($Url, $PathSplit);

	if ($PathStart === FALSE)
		return $PathSplit;

	$Url = substr($Url, $PathStart, $PathEnd - $PathStart);

	return $Url;
}

function PixGallery_UrlBuild($Name, $Value = "")
{
	global $WebsiteUrl;

	$NewUrl		= $WebsiteUrl."?";
	$Query		= $_SERVER['QUERY_STRING']."&";
	$Queries	= explode("&", $Query);
	$Added		= FALSE;

	for ($x = 0; ($x != count($Queries)) && ($Added == FALSE); $x++)
		{
		list($QueryName, $QueryValue) = explode("=", $Queries[$x]);

		if ($QueryName == $Name)
			{
			if ($Value != "")
				$NewUrl .= "&$QueryName=$Value";

			$Added	= TRUE;
			}
		else if ($QueryValue != "")
			$NewUrl .= "&$QueryName=$QueryValue";
		}

	if ($Added == FALSE)
		$NewUrl .= "&$Name=$Value";

	return trim(str_replace("?&", "?", $NewUrl), "?");
}

function PixGallery_DeterminePaths()
{
	global $WebsiteUrl, $WebsiteRoot;


	$ScriptFile = $_SERVER['SCRIPT_FILENAME'];

	if (isset($_SERVER['DOCUMENT_ROOT']))
		$WebsiteRoot = $_SERVER['DOCUMENT_ROOT'];
	else
		$WebsiteRoot = substr($ScriptFile, 0 , (strlen($ScriptFile) - strlen($_SERVER['PHP_SELF'])) + 1);

	if ($WebsiteRoot[strlen($WebsiteRoot) - 1] != "\\")
		$WebsiteRoot .= "\\";

	if (isset($_SERVER['REQUEST_URI']))
		$WebsiteUrl = PixGallery_UrlGetPath($_SERVER['REQUEST_URI']);
	else
		$WebsiteUrl = PixGallery_UrlGetPath($_SERVER['PHP_SELF']);
}

/* ------------------------------------------------------------------------------ */
/* Image functions, html parsing
/* ------------------------------------------------------------------------------ */

function PixGallery_ImageCalculateSizeEx($ImageFile, $LargeSize = FALSE)
{
	global $PixGallery_ImageWidth, $PixGallery_ImageHeight;
	global $PixGallery_ImageWidthLarge, $PixGallery_ImageHeightLarge;

	if ($LargeSize == TRUE)
		return PixGallery_ImageCalculateSize($ImageFile, $PixGallery_ImageWidthLarge, $PixGallery_ImageHeightLarge);
	
	return PixGallery_ImageCalculateSize($ImageFile, $PixGallery_ImageWidth, $PixGallery_ImageHeight);
}

function PixGallery_ImageCalculateSize($ImageFile, $MaximumWidth, $MaximumHeight)
{
	if ((file_exists($ImageFile) === FALSE) && (@getimagesize($ImageFile) === FALSE))
		return array('Width' => 0, 'Height' => 0);

	$ImageObject		= getimagesize($ImageFile);

	$ImageWidth			= $MaximumWidth;
	$ImageHeight		= $MaximumHeight;

	$ImageRealWidth		= $ImageObject[0];
	$ImageRealHeight	= $ImageObject[1];

	$ImagePercentWidth	= ($ImageWidth / $ImageRealWidth);
	$ImagePercentHeight = ($ImageHeight / $ImageRealHeight);

	if ($MaximumWidth == 0)
		$MaximumWidth = FALSE;
	if ($MaximumHeight == 0)
		$MaximumHeight = FALSE;

	if (strpos($MaximumWidth, "px") !== FALSE)
		$MaximumWidth = str_replace("px", "", $MaximumWidth);
	if (strpos($MaximumHeight, "px") !== FALSE)
		$MaximumHeight = str_replace("px", "", $MaximumHeight);

	if ($MaximumWidth !== FALSE && $MaximumHeight === FALSE)
		{
		if (strpos($MaximumWidth, "%") !== FALSE)
			{
			$ImagePercentWidth	= (intval(str_replace("%", "", $MaximumWidth)) / 100);
			$ImageWidth			= round($ImageRealWidth * $ImagePercentWidth);
			}
		else
			$ImageWidth	= round($ImageRealWidth * $ImagePercentWidth);

		if ($ImageRealWidth < $ImageWidth)
			{
			$ImageWidth		= $ImageRealWidth;
			$ImageHeight	= $ImageRealHeight;
			}
		else
			$ImageHeight	= round($ImageRealHeight * $ImagePercentWidth);
		}
	else if ($MaximumWidth === FALSE && $MaximumHeight !== FALSE)
		{
		if (strpos($MaximumHeight, "%") !== FALSE)
			{
			$ImagePercentHeight	= (intval(str_replace("%", "", $MaximumHeight)) / 100);
			$ImageHeight		= round($ImageRealHeight * $ImagePercentHeight);
			}
		else
			$ImageHeight	= round($ImageRealHeight * $ImagePercentHeight);

		if ($ImageRealHeight < $ImageHeight)
			{
			$ImageWidth		= $ImageRealWidth;
			$ImageHeight	= $ImageRealHeight;
			}
		else
			$ImageWidth		= round($ImageRealWidth * $ImagePercentHeight);
		}
	else if ($MaximumWidth !== FALSE && $MaximumHeight !== FALSE)
		{
		if ($ImageRealWidth < $ImageWidth)
			$ImageWidth = $ImageRealWidth;

		$ImageHeight = round(($ImageWidth / $ImageRealWidth) * $ImageRealHeight);

		if ($ImageHeight > $MaximumHeight)
			{
			$ImageHeight	= $MaximumHeight;
			$ImageWidth		= round(($ImageHeight / $ImageRealHeight) * $ImageRealWidth);
			}
		}
	else if ($MaximumWidth === FALSE && $MaximumHeight === FALSE)
		{
		$ImageWidth		= $ImageRealWidth;
		$ImageHeight	= $ImageRealHeight;
		}

	return array('Width' => $ImageWidth, 'Height' => $ImageHeight);
}

/* Set or get the an html tag attribute */

function PixGallery_HtmlAttribute($TagContents, $AttributeName, $AttributeValue = FALSE)
{
	$TagContentsLower	= strtolower($TagContents);
	$AttributeNameLower	= strtolower($AttributeName);

	$AttributeStart = strpos($TagContentsLower, $AttributeNameLower);
	
	if ($AttributeStart === FALSE)
		return FALSE;
	
	$AttributeStart = strpos($TagContentsLower, "=", $AttributeStart);

	while ($TagContents[$AttributeStart++] == ' ');

	$FindEndChar = ' ';

	if ($TagContents[$AttributeStart] == '\'')
		$FindEndChar = '\'';
	if ($TagContents[$AttributeStart] == '"')
		$FindEndChar = '"';
	
	$AttributeEnd = strpos($TagContentsLower, $FindEndChar, $AttributeStart + 1);
	
	if ($FindEndChar != ' ')
		{
		while ($TagContents[$AttributeEnd - 1] == '\\')
			$AttributeEnd = strpos($TagContentsLower, $FindEndChar, $AttributeEnd + 1);

		$AttributeStart++;
		}

	if ($AttributeEnd == FALSE)
		$AttributeEnd = strlen($TagContents);

	if ($AttributeValue == FALSE)
		{
		$AttributeValue = substr($TagContents, $AttributeStart, $AttributeEnd - $AttributeStart);

		return $AttributeValue;
		}

	$NewTagContents = substr($TagContents, 0, $AttributeStart);
	$NewTagContents.= $AttributeValue;
	$NewTagContents.= substr($TagContents, $AttributeEnd);

	return $NewTagContents;
}

function PixGallery_ImageReduce($ImageFileName)
{
	global $PixGallery_ReduceOriginalsWidth, $PixGallery_ReduceOriginalsHeight;

	$MaximumWidth	= $PixGallery_ReduceOriginalWidth;
	$MaximumHeight	= $PixGallery_ReduceOriginalHeight;

	if ($MaximumWidth == 0)
		return FALSE;

	$ImageInfo		= getimagesize($ImageFileName);
	$ImageObject	= FALSE;

	$ImageWidth		= $ImageInfo[0];
	$ImageHeight	= $ImageInfo[1];
	$ImageFileSize	= @filesize($ImageFileName);
	
	if ($ImageFileSize == FALSE)
		{
		PixGallery_PrintError("Error: Photos path must have write permission for reduce originals option!");
		return FALSE;
		}	

	if ($ImageWidth > $MaximumWidth)
		{
		$NewImageSize	= PixGallery_ImageCalculateSize($ImageFileName, $MaximumWidth, $MaximumHeight);

		$NewImageWidth	= $NewImageSize['Width'];
		$NewImageHeight	= $NewImageSize['Height'];

		PixGallery_ImageResize($ImageFileName, $NewImageWidth, $NewImageHeight, $ImageFileName.".tmp");

		unlink($ImageFileName);
		copy($ImageFileName.".tmp", $ImageFileName);
		touch($ImageFileName, filemtime($ImageFileName.".tmp"));
		unlink($ImageFileName.".tmp");		
		}

	return TRUE;
}

function PixGallery_ImageResize($ImageFileName, $NewImageWidth, $NewImageHeight, $NewImageFile = FALSE)
{
	global $WebsiteRoot, $PixGallery_RootCache;

	$ImageInfo		= @getimagesize($ImageFileName);
	$ImageObject	= FALSE;

	if ($NewImageFile == FALSE)
		{
		$NewImageTitle		= PixGallery_UrlGetFileTitle($ImageFileName);
		$NewImageExtension	= PixGallery_UrlGetFileExtension($ImageFileName);
		$NewImageTitle		.= '_'.$NewImageWidth.'x'.$NewImageHeight;
		$NewImageTitle		= rawurldecode($NewImageTitle);
		$NewImageFile		= $WebsiteRoot.$PixGallery_RootCache.$NewImageTitle.$NewImageExtension;

		if ((file_exists($NewImageFile)) && 
			(filemtime($NewImageFile) == @filemtime($ImageFileName)))
			return $NewImageFile;
		}

	switch ($ImageInfo['mime']) 
		{
		case 'image/gif':
			if (imagetypes() & IMG_GIF) 
				$ImageObject = imagecreatefromgif($ImageFileName);
			break;
		case 'image/jpeg':
			if (imagetypes() & IMG_JPG) 
				$ImageObject = imagecreatefromjpeg($ImageFileName);
			break;
		case 'image/png':
			if (imagetypes() & IMG_PNG) 
				$ImageObject = imagecreatefrompng($ImageFileName);
			break;
		case 'image/wbmp':
			if (imagetypes() & IMG_WBMP) 
				$ImageObject = imagecreatefromwbmp($ImageFileName);
			break;
		default:
			echo "Image format not supported [".$ImageInfo['mime']."]";
			break;
		}

	if ($ImageObject == FALSE)
		return FALSE;

	$RealImageWidth		= $ImageInfo[0];
	$RealImageHeight	= $ImageInfo[1];

	if ($RealImageWidth < $NewImageWidth)
		return $ImageFileName;

	$NewImageObject = imagecreatetruecolor($NewImageWidth, $NewImageHeight);
   
	imagecopyresampled($NewImageObject, $ImageObject, 0, 0, 0, 0, $NewImageWidth, $NewImageHeight, $RealImageWidth, $RealImageHeight);

	switch ($ImageInfo['mime']) 
		{
		case 'image/gif':
			imagegif($NewImageObject, $NewImageFile);
			break;
		case 'image/jpeg':
			imagejpeg($NewImageObject, $NewImageFile, 100);
			break;
		case 'image/png':
			imagepng($NewImageObject, $NewImageFile);
			break;
		case 'image/wbmp':
			imagewbmp($NewImageObject, $NewImageFile);
			break;
		default:
			echo "Image format not supported [".$ImageInfo['mime']."]";
			break;
		}
  
	imagedestroy($ImageObject);
	imagedestroy($NewImageObject);

	touch($NewImageFile, filemtime($ImageFileName));

	return $NewImageFile;
}

function PixGallery_Image($Html)
{
	global $WebsiteRoot, $PixGallery_PopupMethod;

	/* Begin parsing html looking for images */

	$HtmlLower		= strtolower($Html);
	$NewHtml		= "";

	$TagName		= "img";
	$TagBeginPrev   = 0;
	$TagBegin		= 0;
	$TagEnd			= 0;

	while (TRUE) 
		{
		$TagBegin = strpos($HtmlLower, "<$TagName", $TagEnd);

		if ($TagBegin === FALSE)
			break;

		$TagEnd	= strpos($HtmlLower, ">", $TagBegin);

		if ($TagEnd	=== FALSE)
			break;

		$TagBegin		+= (strlen($TagName) + 1);
		$TagContents	= substr($Html, $TagBegin, $TagEnd - $TagBegin); 
		$NewHtml		.= substr($Html, $TagBeginPrev, $TagBegin - $TagBeginPrev);
		$TagBeginPrev	= $TagBegin;

		$ImageSource	= PixGallery_HtmlAttribute($TagContents, 'src');

		if ($ImageSource === FALSE)
			continue;

		$ImageWidth		= PixGallery_HtmlAttribute($TagContents, 'width');
		$ImageHeight	= PixGallery_HtmlAttribute($TagContents, 'height');
		$ImageClass		= PixGallery_HtmlAttribute($TagContents, 'class');

		if ($ImageWidth == "")	
			$ImageWidth	= FALSE;
		else
			$ImageWidth = str_replace("px", "", $ImageWidth);

		if ($ImageHeight == "")	
			$ImageHeight = FALSE;
		else
			$ImageHeight = str_replace("px", "", $ImageHeight);

		$ImageNewPath		= "";
		$ImagePath			= $ImageSource;

		if (strpos($ImagePath, "://") === FALSE)
			$ImagePath = $WebsiteRoot.$ImagePath;

		PixGallery_ImageReduce($ImagePath); /* Reduce original image size if need */

		$ImageRealInfo		= @getimagesize($ImagePath);
		
		$ImageRealWidth		= $ImageRealInfo[0];
		$ImageRealHeight	= $ImageRealInfo[1];

		$ImageResizeWidth	= FALSE;
		$ImageResizeHeight	= FALSE;

		$ImageNewSize	= PixGallery_ImageCalculateSize($ImagePath, $ImageWidth, $ImageHeight);

		if (($ImageNewSize['Width'] != $ImageRealWidth) || ($ImageNewSize['Height'] != $ImageRealHeight))
			{
			$ImageNewPath = PixGallery_ImageResize($ImagePath, $ImageNewSize['Width'], $ImageNewSize['Height']);

			$ImageNewPath	= str_replace($WebsiteRoot, "", $ImageNewPath);
			}

		$ImageNewPath	= str_replace($WebsiteRoot, "", $ImageNewPath);

		/* Set image's new width/height, exspecially if it was previously a % */

		if ($ImageWidth !== FALSE)
			$TagContents = PixGallery_HtmlAttribute($TagContents, 'width', $ImageNewSize['Width']);
		if ($ImageHeight !== FALSE)
			$TagContents = PixGallery_HtmlAttribute($TagContents, 'height', $ImageNewSize['Height']);

		if ($ImageNewPath != "")
			{
			$NewTagContents		= PixGallery_HtmlAttribute($TagContents, 'src', $ImageNewPath);
			$NewTagContents		= trim($NewTagContents, "/");

			$ImageOnClick		= PixGallery_HtmlAttribute($TagContents, 'onclick');				
			$ImageAlt			= PixGallery_HtmlAttribute($TagContents, 'alt');
			$ImageNoPopup		= (strpos($TagContents, "nopopup") !== FALSE);
			$ImageAlt			= str_replace("'", "\'", $ImageAlt);

			$PreviousTagIsLink	= FALSE;
			$PreviousTagHtml	= substr($Html, 0, ($TagBegin - strlen($TagName) - 1));
			$PreviousTagBegin	= strrpos($PreviousTagHtml, "<");

			if ($PreviousTagBegin !== FALSE) 
				{
				if (strtolower($PreviousTagHtml[$PreviousTagBegin + 1]) == 'a')
					$PreviousTagIsLink = TRUE;
				}

			if (($ImageOnClick == FALSE) && ($PreviousTagIsLink == FALSE) && 
				($ImageNoPopup == FALSE) && ($PixGallery_PopupMethod != 'NoPopup'))
				{
				$NewTagContents .= " onclick=\"javascript:PixGallery_ImagePopup".$PixGallery_PopupMethod;
				$NewTagContents .= "('$ImageSource', $ImageRealWidth, $ImageRealHeight, '$ImageAlt');\" ";
				$NewTagContents .= "style='cursor: pointer;'";
				}

			if ($ImageClass == FALSE)
				$NewTagContents .= " class='PixGalleryGlobalImage'";

			$NewTagContents		.= "/";

			$NewHtml		.= $NewTagContents;
			$TagBeginPrev	= $TagEnd;
			}
		else
			{
			if ($ImageClass == FALSE)
				$NewHtml .= " class='PixGalleryGlobalImage'";
			}
		}

	$NewHtml .= substr($Html, $TagBeginPrev);

	return $NewHtml; 
}

/* ------------------------------------------------------------------------------ */
/* Photo gallery functions
/* ------------------------------------------------------------------------------ */

function PixGallery_PhotoGallery_CollectionGetContent($Path) 
{
	global $PixGallery_RootWebsite, $GalleryPath, $CollectionPath;

	if ($Path[strlen($Path) - 1] != '/')
		$Path .= "/";

	$ContentList	= null;
	$RealPath		= $PixGallery_RootWebsite.$GalleryPath.$Path;

	if (is_dir($RealPath))
		{
		if ($DirHandle = opendir($RealPath)) 
			{
			while (($FileEntry = readdir($DirHandle)) !== FALSE) 
				{
				if ($FileEntry == '.' || $FileEntry == '..')
					continue;

				$Content				= null;
				$Content['Name']		= $FileEntry;

				if (is_dir($RealPath.$FileEntry))
					$FileEntry .= '/';

				$Content['Path']		= $Path.$FileEntry;
				$Content['FullPath']	= $RealPath.$FileEntry;
				$Content['Link']		= $FileEntry;

				$Extension = PixGallery_UrlGetFileExtension($Content['FullPath']);
				$Extension = strtolower($Extension);

				if (is_dir($Content['FullPath']))
					$Content['Type'] = 'Directory';
				else if ($Extension == '.gif' || $Extension == '.jpg' || $Extension == '.png')
					$Content['Type'] = 'Picture';
				else 
					continue;

				$ContentList[]	= $Content;
				$Count			= count($ContentList) - 1;

				if (isset($ContentList[$Count - 1]['Link']))
					{
					$ContentList[$Count]['Previous']	= $ContentList[$Count - 1]['Link'];
					$ContentList[$Count - 1]['Next']	= $ContentList[$Count]['Link'];
					}
				}
			}
		else
			PixGallery_PrintError("Error: Unable to open path [$Path]!");

		closedir($DirHandle);
		}

	return $ContentList;
}

function PixGallery_PhotoGallery_CollectionGetContentParent($Path)
{
	if ($Path[strlen($Path) - 1] == '/')
		$Path = substr($Path, 0, strlen($Path) - 1);

	$LastSlash = strrpos($Path, "/");

	if ($LastSlash == FALSE)
		return "/";
	
	return substr($Path, 0, $LastSlash + 1);
}

function PixGallery_PhotoGallery_CollectionGetDirectoryImage($Path)
{
	global $CollectionPath;

	$Content = PixGallery_PhotoGallery_CollectionGetContent($CollectionPath.$Path);
	
	for ($i = 0; $i != count($Content); $i += 1)
		{	
		if ($Content[$i]['Type'] == 'Picture')
			return $Content[$i]['Path'];
		}

	return FALSE;
}

function PixGallery_PhotoGallery_Collection()
{
	global $CollectionPath, $GalleryPath, $WebsiteRoot, $QueryPathName;
	global $PixGallery_ImageWidth, $PixGallery_ImageHeight, $PixGallery_Columns;
	global $PixGallery_Rows;

	$FullPath = $WebsiteRoot.$GalleryPath.$CollectionPath;

	if (strpos($CollectionPath, "..") !== FALSE || !file_exists($FullPath))
		{
		PixGallery_PrintError("Error: Path is not secure or does not exist [$CollectionPath]!");
		return $Output;
		}

	$Output					= "";
	$ContentIsFile			= FALSE;
	$ContentPath			= $Path;

	$ContentParentIndex		= 0;
	$ContentParentPath		= PixGallery_PhotoGallery_CollectionGetContentParent($CollectionPath);
	$ContentParent			= PixGallery_PhotoGallery_CollectionGetContent($ContentParentPath);
	$ContentParentUrl		= PixGallery_PhotoGallery_CollectionGetContentParent($CollectionPath);
	$Content				= PixGallery_PhotoGallery_CollectionGetContent($CollectionPath);
	$CollectionRootPath		= PixGallery_UrlGetPath($CollectionPath);
	$ContentParentUrl		= "?$QueryPathName=$ContentParentUrl";

	if (is_file($FullPath))	
		{
		$ContentIsFile	= TRUE;
		$Output			.= "<style>#sidebar { display: none; }</style>";
		}

	$ContentList = null;

	for ($i = 0; $i != count($ContentParent); $i += 1)
		{
		if ($ContentParent[$i]['Path'] == $CollectionPath)
			{
			$ContentParentIndex = $i;

			if ($ContentIsFile == TRUE)
				$ContentList[] = $ContentParent[$i];

			break;
			}
		}

	for ($i = 0; $i != count($Content); $i += 1)
		$ContentList[] = $Content[$i];

	if (($CollectionPath != "/") && ($ContentParentUrl != ""))
		{
		$Output	.= "<a href='$ContentParentUrl'>View Parent Collection</a> | ";

		if ($ContentIsFile == TRUE)
			{
			if (isset($ContentList[0]['Previous']))
				$PreviousLink = $CollectionRootPath.$ContentList[0]['Previous'];
			if (isset($ContentList[0]['Next']))
				$NextLink = $CollectionRootPath.$ContentList[0]['Next'];
			}
		else
			{
			if (isset($ContentParent[$ContentParentIndex]['Previous']))
				$PreviousLink = $ContentParentPath.$ContentParent[$ContentParentIndex]['Previous'];
			if (isset($ContentParent[$ContentParentIndex]['Next']))
				$NextLink = $ContentParentPath.$ContentParent[$ContentParentIndex]['Next'];
			}

		if (isset($PreviousLink))
			$Output .= "<a href='?$QueryPathName=".$PreviousLink."'>Previous</a> | ";

		if (isset($NextLink))
			$Output .= "<a href='?$QueryPathName=".$NextLink."'>Next</a> | ";

		$Output .= "<br><br>";
		}

	$ReadmeFile = $WebsiteRoot.$GalleryPath.$CollectionPath."readme.txt";
	$ReadmeText = "";

	if (file_exists($ReadmeFile))
		$ReadmeText = file_get_contents($ReadmeFile);

	if ($ReadmeText != "")
		$Output .= $ReadmeText."<br><br>";

	$Output		.= "<table border=0 cellspacing=6 cellpadding=2><tr>";
	$Rows		= 0;
	$Columns	= 0;

	for ($i = 0; $i != count($ContentList); $i += 1)
		{
		$ContentName		= $ContentList[$i]['Name'];
		$ContentTitle		= ucfirst(PixGallery_UrlGetFileTitle($ContentName));
		$ContentSize		= "";
		$ContentExtension	= "";

		if ($ContentList[$i]['Type'] == 'Directory')
			{
			$Image				= PixGallery_PhotoGallery_CollectionGetDirectoryImage($ContentName);
			$ImagePath			= $GalleryPath.$Image;
			$ImageRealPath		= $WebsiteRoot.$GalleryPath.$Image;

			$ContentType		= "Gallery";
			}
		else
			{
			$Image				= $ContentList[$i]['Path'];
			$ImagePath			= $GalleryPath.$Image;
			$ImageRealPath		= $WebsiteRoot.$GalleryPath.$Image;

			$ContentExtension	= str_replace(".", "", PixGallery_UrlGetFileExtension($ContentName));
			$ContentSize		= @filesize($ImageRealPath)." B";
			$ContentType		= "Photo";
			}

		$ImageUrl		= "?$QueryPathName=".$ContentList[$i]['Path'];
		$ImageNewSize	= PixGallery_ImageCalculateSizeEx($ImageRealPath, $ContentIsFile);
		$ImageWidth		= $ImageNewSize['Width'];
		$ImageAlt		= trim(str_replace("/", " ", $CollectionRootPath.$ContentTitle));

		if ($ContentIsFile == TRUE)
			{
			$Output .= "<td align=center><img border=0 src='$ImagePath' width='$ImageWidth' class='PixGalleryImage' alt='$ImageAlt'></a><br></td>";
			}
		else
			{
			$Output .= "<td align=center><table border=0 cellpadding=0 cellspacing=0><tr><td height='$PixGallery_ImageHeight;'><a href='$ImageUrl'><img border=0 src='$ImagePath' width='$ImageWidth' class='PixGalleryImage' alt='$ImageAlt'></a><td></tr></table><br><a href='$ImageUrl'>$ContentTitle</a>";
		
			/*$Output .= "<br><span class='PixGalleryContentInfo'>$ContentExtension $ContentType $ContentSize</b></span>";*/

			$Output .= "<br><br></td>";
			}

		if (($Columns + 1) == $PixGallery_Columns)
			{
			$Output		.= "</tr><tr>";
			$Rows		+= 1;
			$Columns	= 0;
			}
		else
			$Columns += 1;
		}

	$Output .= "</tr></table>";

	return $Output;
}

/* Main photo gallery function */

function PixGallery_PhotoGallery($Html) 
{ 
	global $CollectionPath, $GalleryPath;

	$TagName		= "pixgallery"; 
	$TagBegin		= strpos($Html, "<$TagName");
	$TagBeginEnd	= strpos($Html, ">", $TagBegin);
	$TagEnd			= strpos($Html, "</$TagName>");
	
	if (($TagBegin !== FALSE) && ($TagEnd !== FALSE)) 
		{
		$TagContents	= substr($Html, $TagBegin, $TagBeginEnd + 1 - $TagBegin);
		$GalleryPath	= urldecode(PixGallery_HtmlAttribute($TagContents, "path"));
		
		$Text	= substr($Html, 0, $TagBegin);
		$Output = PixGallery_PhotoGallery_Collection();	
	
		if ($CollectionPath != "/")
			$Html = str_replace($Text, "", $Html);

		$Html = str_replace("</$TagName>", "", $Html);
		$Html = str_replace($TagContents, $Output, $Html);
		}

	return $Html; 
} 

/* ------------------------------------------------------------------------------ */
/* Administration panel, setting related, filters, etc
/* ------------------------------------------------------------------------------ */

function PixGallery_Options_Save()
{
	$PixGalleryArray = null;

	$Keys = array_keys($GLOBALS);

	for ($i = 0; $i != count($GLOBALS); $i++)
		{
		if (strpos($Keys[$i], "PixGallery_") !== FALSE)
			$PixGalleryArray[str_replace("PixGallery_", "", $Keys[$i])] = $GLOBALS[$Keys[$i]];
		}

	update_option("PixGallery", $PixGalleryArray);
}

function PixGallery_Options_Load()
{
	$PixGalleryArray = get_option("PixGallery");

	if (is_array($PixGalleryArray) == FALSE)
		{
		PixGallery_Options_Save();
		return;
		}

	$Keys = array_keys($PixGalleryArray);

	for ($i = 0; $i != count($PixGalleryArray); $i++)
		{
		$GLOBALS["PixGallery_".$Keys[$i]] = $PixGalleryArray[$Keys[$i]];
		}
}

function PixGallery_Options_Panel()
{
	global $PixGlobal_Version;

	if (isset($_POST['info_update'])) 
		{
		/* Deal with checkboxes */

		$Keys = array_keys($_POST);
		for ($i = 0; $i != count($_POST); $i++)
			{
			if (strpos($Keys[$i], "PixGallery_") !== FALSE)
				{
				$Value = stripslashes($_POST[$Keys[$i]]);

				if ($Value == "on") 
					$Value = '1';

				$GLOBALS[$Keys[$i]] = $Value;
				}
			}

		PixGallery_Options_Save();

		echo "<div class='updated'><p><strong>Settings saved successfully!</strong></p></div>";
		}

	$LatestVersionUrl = "http://www.nathanm.com/projects/pixgallery-version.txt";

	if (ini_get('allow_url_fopen') != '1')
		$LatestVersion = $PixGlobal_Version;
	else
		$LatestVersion = file_get_contents($LatestVersionUrl);

?>

<div class=wrap>
  <form method="post">

    <h2>Photo Gallery Settings </h2>

<?php if ($LatestVersion != $PixGlobal_Version) { ?>
	<font color=#e12b13>There is a new version available <?=$LatestVersion?>! You are currently using version <?=$PixGlobal_Version;?>.<br> To download the latest version please goto http://www.nathanm.com/index.php/pixgallery/<br><br></font>
<?php } ?>

<fieldset class="options">
<legend>Gallery Layout</legend>
<blockquote>
	<table border=0 cellpadding=0 cellspacing=0>
		<tr>
			<td width="360">Number of columns per gallery page (0 = unlimited)</td>
			<td align=right><input type='text' name='PixGallery_Columns' style='width: 20px;' value='<?=$GLOBALS["PixGallery_Columns"]?>'></td>
		</tr>
	</table>
	<br>
	<table border=0 cellpadding=0 cellspacing=0>
		<tr>
			<td width="360">Number of rows per gallery page (0 = unlimited)</td>
			<td align=right><input type='text' name='PixGallery_Rows' style='width: 20px;' value='<?=$GLOBALS["PixGallery_Rows"]?>'></td>
		</tr>
	</table>
</blockquote>
<legend>Gallery Images</legend>
<blockquote>
	<table border=0 cellpadding=0 cellspacing=0>
		<tr>
			<td width="360">Maximum small thumbnail image size (0 = no max)</td>
			<td align=right><input type='text' name='PixGallery_ImageWidth' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ImageWidth"]?>'> px <input type='text' name='PixGallery_ImageHeight' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ImageHeight"]?>'> px</td>
		</tr>
	</table>
	<br>
	<table border=0 cellpadding=0 cellspacing=0>
		<tr>
			<td width="360">Maximum large thumbnail image size (0 = no max)</td>
			<td align=right><input type='text' name='PixGallery_ImageWidthLarge' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ImageWidthLarge"]?>'> px <input type='text' name='PixGallery_ImageHeightLarge' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ImageHeightLarge"]?>'> px</td>
		</tr>
	</table>
	<br>
	Reduce images in photos path (0 = disabled)
	<br><br>
	<input type='text' name='PixGallery_ReduceOriginalsWidth' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ReduceOriginalsWidth"]?>'> px <input type='text' name='PixGallery_ReduceOriginalsHeight' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ReduceOriginalsHeight"]?>'> px</td>
	<br><br>
	If you often upload pictures straight from your digital camera, you can use this option to reduce the actual size of the images in your photos directory. Specify the image width you want your images to reduced to. If you use this option, your photos directory and all subdirectories must have write permissions.
	<br><br>
	Popup window method
	<br><br>
	<select name='PixGallery_PopupMethod'>

		<option value='NoPopup'	<?php if ($GLOBALS["PixGallery_PopupMethod"] == 'NoPopup') echo "selected"; ?>>None</option>
		<option value='Window'	<?php if ($GLOBALS["PixGallery_PopupMethod"] == 'Window') echo "selected"; ?>>New Window</option>
		<option value='Layer'	<?php if ($GLOBALS["PixGallery_PopupMethod"] == 'Layer') echo "selected"; ?>>New Layer</option>

	</select>
	<br><br>
	Normally the large thumbnail images are not the actual width and height of the image file. If you want your users to be able to view the actual image file in a popup window or popup layer when clicking on large thumbnails then this option is for you.
	<br><br>
</blockquote>
<legend>Cache Path</legend>
<blockquote>
	<input type='text' name='PixGallery_RootCache' style='width: 350px;' value='<?=$GLOBALS["PixGallery_RootCache"]?>'>
	<br><br>
	Relative path to your cache directory which has write permissions. This directory is used to store the thumbnail images that are created.
</blockquote>
</fieldset>

<div class="submit"><input type="submit" name="info_update" value="Apply Options" /></div>

</form>
</div>

<?php
}

function PixGallery_Options_Hook() 
{
    if (function_exists('add_options_page'))
		add_options_page('PixGallery Settings', 'PixGallery', 8, basename(__FILE__), 'PixGallery_Options_Panel');
}

/* ------------------------------------------------------------------------------ */
/* Plugin stuff..
/* ------------------------------------------------------------------------------ */

function PixGallery_Header()
{
	global $WebsiteRoot;
	
?>

<!-- Start of PixGallery Global -->
<link rel="stylesheet" href="<?=get_option('home')?>/wp-content/plugins/pixgallery.css" type="text/css" />
<script language='javascript' type='text/javascript' src='<?=get_option('home')?>/wp-content/plugins/pixgallery.js'></script>
<table border=0 cellpadding=0 cellspacing=0 id='PixGalleryPopupLayer' name="PixGalleryPopupLayer" class="PixGalleryPopupDrag"><tr><td><table width='100%' border=0 cellpadding=0 cellspacing=2><tr><td width='100%' id='PixGalleryPopupText'><div name="PixGalleryPopupText">&nbsp;</div></td><td width='50' id="PixGalleryPopupClose"><div onclick='javascript:PixGallery_ImagePopupLayerClose();'>Close</div></td></tr></table></td><tr><tr><td colspan=2><img id='PixGalleryPopupImage'></td></tr></table>
<!-- End of PixGallery Global -->

<?php
}

add_action('wp_head',		'PixGallery_Header');
add_action('admin_menu',	'PixGallery_Options_Hook');
add_filter('the_content',	'PixGallery_PhotoGallery');
add_filter('the_content',	'PixGallery_Image');

?>
